#include <windows.h>
#include "stdio.h"
#include "MT.h"
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
char szClassNme[] = "wclass";

int BenchDrawingString(HWND, char *);
void ReadSettings();
void ReleaseMemory();


const int WX = 800;
const int WY = 600;

const char INIFILE[] = "./GdiBench.ini";

char *Words[256];
// Pz
// 0Ԗڂ͊i[Ă
// evfcharzւ̃|C^
// vJ
unsigned char WordLeng[256];
// ̃oCg(WordsɑΉ)
char *Text[16384];
// eLXgt@C
// evf͍scharzւ̃|C^
// vJ
int TextH;
// eLXg̍s
unsigned char TextLeng[16384];
// eLXg̍s̕oCg
char FontName[64];
// tHg
int Times;
// ̕`
char TextFile[64];
// eLXgt@C
int FontSize;
int SaveLog;
char LogFileName[64];
// Oۑ邩ǂƂ̃t@C

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst,LPSTR lpszCmdLine, int nCmdShow)
{
	HWND hWnd;
	MSG msg;
	WNDCLASS myProg;
	if (!hPreInst) {
		myProg.style			= CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc		= WndProc;
		myProg.cbClsExtra		= 0;
		myProg.cbWndExtra		= 0;
		myProg.hInstance		= hInstance;
		myProg.hIcon			= NULL;
		myProg.hCursor			= LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		myProg.lpszMenuName		= NULL;
		myProg.lpszClassName	= szClassNme;
		if (!RegisterClass(&myProg))
			return FALSE;
	}
	hWnd = CreateWindow(
		szClassNme,
		"GDI++ x`}[N",
		WS_OVERLAPPEDWINDOW,
		24,
		20,
		WX,
		WY,
		NULL,
		NULL,
		hInstance,
		NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	
	InitMt(GetTickCount());
	
	ReadSettings();
	
	char text[256];
	BenchDrawingString(hWnd, text);
	MessageBox(hWnd, text, "",MB_OK);
	
	ReleaseMemory();
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (msg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}

int BenchDrawingString(HWND hWnd,char *text)
{
	HINSTANCE hDll;
	HFONT hFont;
	HDC hDC;
	hDC = GetDC(hWnd);
	int t[2],tt[2],n, i, j;
	n = WY / (FontSize + 1);
	hFont = CreateFont(FontSize,0,0,0,FW_NORMAL,0,0,0,
					  SHIFTJIS_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
					  DEFAULT_QUALITY ,DEFAULT_PITCH |FF_DONTCARE,FontName);
	SelectObject(hDC, hFont);
	SetTextAlign(hDC, TA_CENTER);
	for (int k=0; k<2; k++) {
		
		SetTextAlign(hDC, TA_CENTER);
		SetBkMode(hDC, OPAQUE);
		
		t[k] = GetTickCount();
		for (i = 0; i < Times; i++) {
			for (j = 1; j <= *Words[0]; j++) {
				SetTextColor(hDC,Mt() % 0x1000000);
				TextOut(hDC , Mt() % WX , Mt() % WY , Words[j] , WordLeng[j]);
				Sleep(100);
			}
		}
		
		SetBkMode(hDC, TRANSPARENT);
		for (i = 0; i < Times; i++) {
			for (j = 1; j <= *Words[0]; j++) {
				SetTextColor(hDC,Mt() % 0x1000000);
				TextOut(hDC , Mt() % WX , Mt() % WY , Words[j] , WordLeng[j]);
			}
		}
		t[k] = GetTickCount() - t[k];
		
		SelectObject(hDC, (HBRUSH)GetStockObject(WHITE_BRUSH));
		
		SetTextAlign(hDC, TA_LEFT);
		SetBkMode(hDC, OPAQUE);
		SetTextColor(hDC,0);
		
		tt[k] = GetTickCount();
		for (i = 0; i < (TextH / n); i++) {
			Rectangle(hDC,0,0,WX,WY);
			for (j = 0; j < n; j++) {
			TextOut(hDC , 4 , j * (FontSize + 1) , Text[j + i * n] , TextLeng[j + i * n]);
			}
		}
		tt[k] = GetTickCount() - tt[k];
		
		hDll = LoadLibraryEx("gdi++.dll",NULL,0);
		if( ! hDll ) {
			MessageBox(0, "gdi++.dllJȂ", "", MB_OK);
			break;
		}
	}
	sprintf(text,"    茋\n\nGDI32   \n P@@  %d ms\n eLXg  %d ms\ngdi++   \n P@@  %d ms\n eLXg  %d ms\n",t[0],tt[0],t[1],tt[1]);
	if (SaveLog) {
		FILE *f;
		f = fopen(LogFileName, "a+");
		fputs(text, f);
		fclose(f);
	}
	FreeLibrary( hDll );
	DeleteObject(hFont);
	ReleaseDC( hWnd, hDC );
	return 0;
}

void ReadSettings()
{
	int i;
	char temp[16];
	char WordTemp[256];
	Words[0] = new char;

	SaveLog = GetPrivateProfileInt("GdiBench", "SaveLog", 1, INIFILE );
	Times = GetPrivateProfileInt("GdiBench", "Times", 5000, INIFILE );
	FontSize = GetPrivateProfileInt("GdiBench", "FontSize", 18, INIFILE );
	GetPrivateProfileString("GdiBench", "LogFileName", "GdiBench.log", LogFileName, 63, INIFILE );
	GetPrivateProfileString("GdiBench", "FontName", "lr oSVbN", FontName, 63, INIFILE );
	GetPrivateProfileString("GdiBench", "TextName", "", TextFile, 63, INIFILE );
	*Words[0] = GetPrivateProfileInt("Word", "Count", 1, INIFILE );
	if (*Words[0] > 126)
		*Words[0] = 126;
	for (i = 1; i <= *Words[0]; i++) {
		sprintf(temp, "%d", i);
		GetPrivateProfileString("Word", temp, "GDI++̔", WordTemp, 127, INIFILE );
		WordLeng[i] = strlen(WordTemp);
		Words[i] = new char[WordLeng[i] + 1];
		strcpy( Words[i], WordTemp);
	}
	FILE *textfile;
	textfile = fopen(TextFile, "r");
	if (!textfile){
		MessageBox(0, "eLXgt@CJȂ", "", MB_OK);
	} else {
		for (i = 0; fgets(WordTemp, 255, textfile) != NULL; i++) {
			if (i > 16384) {
				break;
			}
			TextH=i;
			TextLeng[i] = strlen(WordTemp);
			Text[i] = new char[TextLeng[i] + 1];
			Text[i][0] = 0;
			strcpy( Text[i],  WordTemp);
		}
	}
	fclose(textfile);
}

void ReleaseMemory()
{
	int i;
	for (i = 1; i <= *Words[0]; i++) {
		delete[] Words[i];
	}
	delete Words[0];
	for (i = 0; i <= TextH; i++) {
		delete[] Text[i];
	}
	
}